﻿© 2007 Fluke Corporation, All rights reserved               MET/CAL Procedure
=============================================================================
INSTRUMENT:            Sub Wait for Operation Complete (OPC) RS-232
DATE:                  2007-07-10 10:01:41
AUTHOR:                Fluke Corporation
REVISION:              $Revision: 17933 $
ADJUSTMENT THRESHOLD:  70%
NUMBER OF TESTS:       1
NUMBER OF LINES:       99
=============================================================================
#
# Compatibility:
#   5500/CAL or MET/CAL 7.01 SP2 or later
#
# Subprocedures:
#   None
#
# Required Files:
#   None
#
# Usage:
#
#   Serial output terminator must be set in main procedure using the output
#   terminator special construction ([OTERM <term>]).
#
#   The main procedure must set the OPC timeout in milliseconds.
#   Example:
#      MATH     MEM2 = PUT("OPC_Timeout", 30000)
#
#   GET("Error")
#     = 0 OPC bit in Extended Status Register (ESR) is set
#     = 1 An error occurred
#
#   GET("Err_Msg")
#     Contains error text when GET("Error") is true.
#
 STEP    FSC    RANGE NOMINAL        TOLERANCE     MOD1        MOD2  3  4 CON
  1.001  MATH         L[30] = MEM; L[31] = MEM1; L[1] = 0
  1.002  MATH         MEM2 = PUT("ESB", 0); MEM2 = PUT("Timeout", 0)
  1.003  MATH         MEM2 = PUT("Error", 0); MEM2 = PUT("Err_Msg", "")

# Set Operation Complete bit (OPC) in Event Status Register (ESR) to 1 when
# all pending operations have completed.
  1.004  PORT         *OPC

# Wait for OPC loop.
  1.005  DO
  1.006  WAIT         [D100]
  1.007  PORT         *ESR?[I]

# Ignore "Power On" (Bit 7)
  1.008  IF           MEM >= 128
  1.009  MATH         MEM = MEM - 128
  1.010  ENDIF

  1.011  IF           MEM > 0
  1.012  MATH         MEM2 = PUT("ESB", 1)
  1.013  ENDIF

  1.014  MATH         L[1] = L[1] + 100

  1.015  IF           L[1] > GET("OPC_Timeout")
  1.016  MATH         MEM2 = PUT("Timeout", 1)
  1.017  ENDIF

  1.018  UNTIL        GET("ESB") || GET("Timeout")

  1.019  IF           GET("Timeout")
  1.020  MATH         MEM2 = "Timeout waiting for Operation Complete (OPC)."
  1.021  ELSEIF       BIT(7, MEM)
  1.022  MATH         MEM2 = "Power On"
  1.023  ELSEIF       BIT(6, MEM)
  1.024  MATH         MEM2 = "User Request"
  1.025  ELSEIF       BIT(5, MEM)
  1.026  MATH         MEM2 = "Command Error"
  1.027  ELSEIF       BIT(4, MEM)
  1.028  MATH         MEM2 = "Execution Error"
  1.029  ELSEIF       BIT(3, MEM)
  1.030  MATH         MEM2 = "Device Dependent Error"

  1.031  ELSEIF       BIT(2, MEM)
  1.032  MATH         MEM2 = "Query Error"
  1.033  ELSEIF       BIT(1, MEM)
  1.034  MATH         MEM2 = "Request Control"
  1.035  ELSE
  1.036  MATH         MEM2 = ""
  1.037  ENDIF

  1.038  IF           ZCMP(MEM2, "") == 0
  1.039  OPBR         [MEM2]
  1.039  OPBR
  1.039  OPBR         Do you wish to continue?
  1.040  MATH         MEM2 = PUT("Error", (MEM1 > 0))
  1.041  MATH         MEM2 = PUT("Err_Msg", MEM2)
  1.042  ENDIF

# Restore MEM and MEM1.
  1.043  MATH         MEM = L[30]; MEM1 = L[31]
  1.044  END
